// Begin $Header: /cygdrive/c/src/usi/RCS/usi.c,v 1.5 2002/10/18 14:15:57 PC3 Exp $
// UDA'Software 2002
// $Date: 2002/10/18 14:15:57 $
// $Revision: 1.5 $

/*
  Questo programma serve per fornire dei comandi utili alla shell del
  DOS, come ad esempio:

  .) Verificare i parametri di un disco (spazio totale, usato,
  disponibile).

  .) Verificare i parametri di un file (dimensione, attributi, data
  creazione, ecc...).

  .) Accessibilita' ad una risorsa (lettura, scrittura, entrambe).

  .) Messaggi di avvertimento e richiesta vari.
*/

/*

  Copyright (C) 1988 Free Software Foundation, Inc.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

// *******************************************************************
//____________________________________________________________________
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

// *******************************************************************
//____________________________________________________________________
#define UDAMSGBOXTITLE	"UDA System Informations - Version 1.2 - http://digilander.libero.it/udasoft"

// *******************************************************************
//____________________________________________________________________
void USI_Help() {
  printf("                                                                                ");	// 1
  printf("  UDA System Informations - Version 1.0 - http://digilander.libero.it/udasoft   ");	// 2
  printf("                                                                                ");	// 3
  printf(" Questo programma serve per fornire all'utente MS-DOS che lavora su un sistema  ");	// 4
  printf("Windows NT di strumenti addizionali utili a svolgere compiti come il            ");	// 5
  printf("controllo spazio disco, attributi file (dimensione, data, ecc...), accesso in   ");	// 6
  printf("lettura/scrittura su risorsa e messaggi di dialogo; a seconda dell'esito, la    ");	// 7
  printf("variabile d'ambiante ERRORLEVEL viene opportunamente impostata.                 ");	// 8
  printf(" La sintassi del programma e':                                                  ");	// 9
  printf("                                                                                ");	// 10
  printf("                 usi <comando> <subcomando> <parametri>                         ");	// 11
  printf("                                                                                ");	// 12
  printf(" I comandi disponibili con i relativi subcomandi sono i seguenti:               ");	// 13
  printf("                                                                                ");	// 14
  printf(" o) diskspace  <total/used/size> <disk>                                         ");	// 15
  printf("    total          -> Restituisce lo spazio massimo disponibile sul disco       ");	// 16
  printf("    used           ->      ''     ''   ''   usato sul disco                     ");	// 17
  printf("    free           ->      ''     ''   ''   libero sul disco                    ");	// 18
  printf("                                                                                ");	// 19
  printf(" o) filedata   <size/attrib/time...> <nomefile>                                 ");	// 20
  printf("    size           -> Restituisce la dimensione del file                        ");	// 21
  printf("    attrib         ->      ''     un valore che varia a seconda degli attributi ");	// 22
  printf("    timecreation   ->      ''     ''   ''   identificativo della creazione      ");	// 23
  printf("    timelastmod    ->      ''     ''   ''         ''         ''  modifica       ");	// 24

  printf("    timelastacc    ->      ''     ''   ''         ''       dell'ultimo accesso  ");	// 1
  printf("                                                                                ");	// 2
  printf(" o) fileaccess <read/write/readwrite> <nomefile>                                ");	// 3
  printf("    read           -> Verifica se riesce a leggere dal file                     ");	// 4
  printf("    write          ->      ''  ''   ''   a scrivere sul file (senza modificarlo)");	// 5
  printf("    readwrite      ->      ''  ''   ''   a leggere/scrivere sul file            ");	// 6
  printf("                                                                                ");	// 7
  printf(" o) msgbox     <ok/alert/error/ques...> <message> <title>                       ");	// 8
  printf("    ok             -> Apre un Messaggio di Dialogo per Conferma                 ");	// 9
  printf("    alert          ->  ''  ''     ''    ''    ''   ''  Avvertimento             ");	// 10
  printf("    error          ->  ''  ''     ''    ''    ''   ''  Errore                   ");	// 11
  printf("    question       ->  ''  ''     ''    ''    ''   ''  Richiesta                ");	// 12
  printf("    questioncancel ->  ''  ''     ''    ''    ''   ''  Richiesta con Annulla    ");	// 13
  printf("                                                                                ");	// 14
  printf(" o) help           -> Visualizza questa guida                                   ");	// 15
  printf("                                                                                ");	// 16
  printf(" Ecco alcuni esempi (ricordarsi di utilizzare le virgolette \" per i parametri):");	// 17
  printf("  usi diskspace total c:                                                        ");	// 18
  printf("  usi diskspace free \"\\\\miopc\\discoD\"                                           ");	// 18
  printf("  usi filedata size c:\\\\autoexec.bat                                            ");	// 19
  printf("  usi fileaccess read \"c:\\autoexec.bat\"                                         ");	// 20
  printf("  usi msgbox ok \"L'Operazione e' stata completata\" \"Mio messaggio\"              ");	// 22
  printf("  usi msgbox questioncancel \"Vuoi veramente cambiare ?\" \"Domanda Windows\"\n");	// 23
}

// *******************************************************************
//____________________________________________________________________
#define SPACE_TOTAL	0
#define SPACE_USED	1
#define SPACE_FREE	2
int GetDiskSpace(char *psResource, DWORD dwMode) {
  char			acULItoText[32];
  ULARGE_INTEGER
    FreeBytesAvailableToCaller,
    TotalNumberOfBytes,
    TotalNumberOfFreeBytes, 
    TotalNumberOfUsedBytes;

  if (psResource && strlen(psResource)) {
    if (!GetDiskFreeSpaceEx(psResource,
			    &FreeBytesAvailableToCaller,
			    &TotalNumberOfBytes,
			    &TotalNumberOfFreeBytes)) {
      return 0;
    }
    
    switch (dwMode) {
    case SPACE_TOTAL:
      _ui64toa(TotalNumberOfBytes.QuadPart, acULItoText, 10);
      printf("%s", acULItoText);
      
      break;
    case SPACE_USED:
      TotalNumberOfUsedBytes.QuadPart = TotalNumberOfBytes.QuadPart - TotalNumberOfFreeBytes.QuadPart;
      _ui64toa(TotalNumberOfUsedBytes.QuadPart, acULItoText, 10);
      printf("%s", acULItoText);
      
      break;
    case SPACE_FREE:
      _ui64toa(TotalNumberOfFreeBytes.QuadPart, acULItoText, 10);
      printf("%s", acULItoText);
      
      break;
    default:
      MessageBox(NULL, 
		 "ERRORE INTERNO: int GetDiskSpace(char *psResource, DWORD dwMode): Chiamata errata.", 
		 UDAMSGBOXTITLE, 
		 MB_OK);

      return 0;
    };
  }

  return 1;
}

// *******************************************************************
//____________________________________________________________________
#define DATA_SIZE	0
#define DATA_ATTRIB	1
#define DATA_TIMECR	2
#define DATA_TIMEAC	3
#define DATA_TIMEMD	4
int GetFileData(const char *psResource, DWORD dwMode) {
  HANDLE		hFile = 0;
  WIN32_FIND_DATAA	win32_find_data;

  memset(&win32_find_data, 0, sizeof(WIN32_FIND_DATAA));

  if (psResource && strlen(psResource)) {
    hFile = FindFirstFile(psResource, &win32_find_data);
    if (hFile != INVALID_HANDLE_VALUE) {
      switch(dwMode) {
      case DATA_SIZE:	// Ritorna la dimensione del file
	// nFileSizeHigh nFileSizeLow
	printf("%d", win32_find_data.nFileSizeHigh ? win32_find_data.nFileSizeHigh : win32_find_data.nFileSizeLow);
	break;
      case DATA_ATTRIB:	// Ritorna gli attributi del file
	// dwFileAttributes
	// 1	read only
	// 2	hide
	// 32	archive
	// 128	none
	// 2048	compress
	printf("%d", win32_find_data.dwFileAttributes);
	break;
      case DATA_TIMECR:	// Ritorna la data di creazione
	// ftCreationTime .dwLowDateTime .dwHighDateTime
	printf("%u", win32_find_data.ftCreationTime.dwLowDateTime);
	break;
      case DATA_TIMEAC:	// Ritorna la data di ultimo accesso
	// ftLastAccessTime .dwLowDateTime .dwHighDateTime
	printf("%u", win32_find_data.ftLastAccessTime.dwLowDateTime);
	break;
      case DATA_TIMEMD:	// Ritorna la data di ultima modifica
	// ftLastWriteTime .dwLowDateTime .dwHighDateTime
	printf("%u", win32_find_data.ftLastWriteTime.dwLowDateTime);
	break;
      default:
	MessageBox(NULL, 
		   "ERRORE INTERNO: int GetFileData(char *psResource, DWORD dwMode): Chiamata errata.", 
		   UDAMSGBOXTITLE, 
		   MB_OK);
	
	return 0;
      };
      
      return 1;
    }
  }

  return 0;
}

// *******************************************************************
//____________________________________________________________________
#define FILE_READ	0
#define FILE_WRITE	1
#define FILE_READWRITE	2
int GetFileAccess(const char *psResource, DWORD dwMode) {
  FILE		*pFile = 0;

  if (psResource && strlen(psResource)) {
    switch(dwMode) {
    case FILE_READ:
      pFile = fopen (psResource, "r");	// Apre il file in sola lettura
      break;
    case FILE_WRITE:
      pFile = fopen (psResource, "a");	// Apre il file in sola scrittura (append)
      break;
    case FILE_READWRITE:
      pFile = fopen (psResource, "rw");	// Apre il file in lettura/scrittura
      break;
    default:
      MessageBox(NULL, 
		 "ERRORE INTERNO: int GetFileAccess(char *psResource, DWORD dwMode): Chiamata errata.", 
		 UDAMSGBOXTITLE, 
		 MB_OK);
      
      return 0;
    };

    // Verifica se l'operazione e' riuscita.
    if (!pFile) {
      printf("%s", strerror(errno));
      
      return 0;
    }

    close(pFile);
    printf("ok");

    return 1;
  }

  return 0;
}

// *******************************************************************
//____________________________________________________________________
#define MSGBOX_OK	0
#define MSGBOX_ALERT	1
#define MSGBOX_ERROR	2
#define MSGBOX_QUESTION	3
#define MSGBOX_QUESTCAN	4
int MsgBox(const char *psMessage, const char *psTitle, DWORD dwMode) {
  if (psTitle && strlen(psTitle) && 
      psMessage && strlen(psMessage)) {
    switch(dwMode) {
    case MSGBOX_OK:
      return MessageBox(NULL, psMessage, psTitle, MB_OK);
      break;
    case MSGBOX_ALERT:
      return MessageBox(NULL, psMessage, psTitle, MB_OK | MB_ICONWARNING);
      break;
    case MSGBOX_ERROR:
      return MessageBox(NULL, psMessage, psTitle, MB_OK | MB_ICONERROR);
      break;
    case MSGBOX_QUESTION:
      return MessageBox(NULL, psMessage, psTitle, MB_YESNO | MB_ICONQUESTION);
      break;
    case MSGBOX_QUESTCAN:
      return MessageBox(NULL, psMessage, psTitle, MB_YESNOCANCEL | MB_ICONQUESTION);
      break;
    default:
      MessageBox(NULL, 
		 "ERRORE INTERNO: int MsgBox(const char *psMessage, const char *psTitle, DWORD dwMode): Chiamata errata.", 
		 UDAMSGBOXTITLE, 
		 MB_OK);
      
      return 0;
    };
  }

  return 0;
}

// *******************************************************************
//____________________________________________________________________
int main (int argc, char **argv) {
  int		iCommandIterator = 0;

  // Lista dei comandi principali supportati dal programma.
  char		*vsCommands[] = {
    "diskspace",	// 0
    "filedata",		// 1
    "fileaccess",	// 2
    "msgbox",		// 3
    "help",		// 4
    "#end"
  };

  // Lista dei sottocomandi supportati dal programma: DISKSPACE
  char		*vsSubCommands_diskspace[] = {
    "total",		// 0
    "used",		// 1
    "free",		// 2
    "#end"
  };

  // Lista dei sottocomandi supportati dal programma: FILEDATA
  char		*vsSubCommands_filedata[] = {
    "size",		// 0
    "attrib",		// 1
    "timecreation",	// 2
    "timelastmod",	// 3
    "timelastacc",	// 4
    "#end"
  };

  // Lista dei sottocomandi supportati dal programma: FILEACCESS
  char		*vsSubCommands_fileaccess[] = {
    "read",		// 0
    "write",		// 1
    "readwrite",	// 2
    "#end"
  };

  // Lista dei sottocomandi supportati dal programma: MSGBOX
  char		*vsSubCommands_msgbox[] = {
    "ok",		// 0
    "alert",		// 1
    "error",		// 2
    "question",		// 3
    "questioncancel",	// 4
    "#end"
  };

  // Verifica che il programma sia stato invocato con sufficienti
  // parametri.
  if (argc < 4 && strcasecmp(argc == 2 ? argv[1] : "pleh", "help")) {
    MessageBox(NULL, 
	       "ERRORE: Il programma non  stato lanciato con sufficienti parametri. Usare il parametro help per ottenere aiuto.", 
	       UDAMSGBOXTITLE, 
	       MB_OK);

    return 1;
  }

  while(vsCommands[iCommandIterator][0] != '#' && iCommandIterator >= 0) {
    if (strstr(vsCommands[iCommandIterator], argv[1]) &&	// Se viene incontrata una stringa simile al comando e
	!strcasecmp(vsCommands[iCommandIterator], argv[1])) {	// confrontandola risulta uguale, significa che lo ha trovato.
      switch (iCommandIterator) {
      case 0:
	iCommandIterator = 0;
	while(vsSubCommands_diskspace[iCommandIterator][0] != '#') {
	  if (strstr(vsSubCommands_diskspace[iCommandIterator], argv[2]) && 
	      !strcasecmp(vsSubCommands_diskspace[iCommandIterator], argv[2])) {
	    if (argc == 4) {
	      if (!GetDiskSpace(argv[3], iCommandIterator)) {	// iCommandIterator: il suo valore corrisponde alla modalita' da usare.
		MessageBox(NULL, 
			   "ATTENZIONE: Non e' stato possibile eseguire la verifica del device specificato.", 
			   UDAMSGBOXTITLE, 
			   MB_OK);
		
		return 1;
	      } else
		return 0;
	    }
	  }
	  ++iCommandIterator;
	}
	iCommandIterator = -2;	// Esce dal ciclo con errore.
	break;
      case 1:
	iCommandIterator = 0;
	while(vsSubCommands_filedata[iCommandIterator][0] != '#') {
	  if (strstr(vsSubCommands_filedata[iCommandIterator], argv[2]) && 
	      !strcasecmp(vsSubCommands_filedata[iCommandIterator], argv[2])) {
	    if (argc == 4) {
	      if (!GetFileData(argv[3], iCommandIterator)) {
		MessageBox(NULL, 
			   "ATTENZIONE: Non e' stato possibile eseguire la verifica del file specificato.", 
			   UDAMSGBOXTITLE, 
			   MB_OK);
		
		return 1;
	      } else
		return 0;
	    }
	  }
	  ++iCommandIterator;
	}
	iCommandIterator = -2;	// Esce dal ciclo con errore.
	break;
      case 2:
	iCommandIterator = 0;
	while(vsSubCommands_fileaccess[iCommandIterator][0] != '#') {
	  if (strstr(vsSubCommands_fileaccess[iCommandIterator], argv[2]) && 
	      !strcasecmp(vsSubCommands_fileaccess[iCommandIterator], argv[2])) {
	    if (argc == 4) {
	      if (!GetFileAccess(argv[3], iCommandIterator)) {
		// Ritorna direttamente l'errore del sistema
		// operativo.
		return errno;
	      } else
		return 0;
	    }
	  }
	  ++iCommandIterator;
	}
	iCommandIterator = -2;	// Esce dal ciclo con errore.
	break;
      case 3:
	iCommandIterator = 0;
	while(vsSubCommands_msgbox[iCommandIterator][0] != '#') {
	  if (strstr(vsSubCommands_msgbox[iCommandIterator], argv[2]) && 
	      !strcasecmp(vsSubCommands_msgbox[iCommandIterator], argv[2])) {
	    if (argc == 5) {
	      return MsgBox(argv[3], argv[4], iCommandIterator);
	    }
	  }
	  ++iCommandIterator;
	}
	iCommandIterator = -2;	// Esce dal ciclo con errore.
	break;
      case 4:
	USI_Help();
	return 2;
      default:
	MessageBox(NULL, 
		   "ERRORE INTERNO: La routine che esegue il parsing della riga di comando ha eseguito un'operazione non valida.", 
		   UDAMSGBOXTITLE, 
		   MB_OK);
	
	return 1;
      };
    }
    // Passa a controllare il comando successivo.
    ++iCommandIterator;
  }

  MessageBox(NULL, 
	     "ERRORE: Il comando non  stato riconosciuto o non  stato utilizzato correttamente. Consulatare la guida del programma per ottenere aiuto.", 
	     UDAMSGBOXTITLE, 
	     MB_OK);
  
  return 1;
}

// *******************************************************************
//____________________________________________________________________
// End $Source: /cygdrive/c/src/usi/RCS/usi.c,v $
